'
' ----------------------------------------------------------------------------
' New QOpenDialog      March 3rd,  2006        by Jacques         Version  002
'
' This is based on RQDIALOG.INC  by  BILL K  1-2003
' ----------------------------------------------------------------------------
TYPE OPENDLG_OPENFILENAME
    lStructSize AS LONG
    hwndOwner AS LONG
    hInstance AS LONG
    lpstrFilter AS LONG
    lpstrCustomFilter AS LONG
    nMaxCustFilter AS LONG
    nFilterIndex AS LONG
    lpstrFile AS LONG
    nMaxFile AS LONG
    lpstrFileTitle AS LONG
    nMaxFileTitle AS LONG
    lpstrInitialDir AS LONG
    lpstrTitle AS LONG
    flags AS LONG
    nFileOffset AS SHORT
    nFileExtension AS SHORT
    lpstrDefExt AS LONG
    lCustData AS LONG
    lpfnHook AS LONG
    lpTemplateName AS LONG
END TYPE
' ----------------------------------------------------------------------------
Const OPENDLG_OFN_ALLOWMULTISELECT = 512
Const OPENDLG_OFN_CREATEPROMPT = &H2000
Const OPENDLG_OFN_ENABLEHOOK = 32
Const OPENDLG_OFN_ENABLETEMPLATE = 64
Const OPENDLG_OFN_ENABLETEMPLATEHANDLE = 128
Const OPENDLG_OFN_EXPLORER = &H80000
Const OPENDLG_OFN_EXTENSIONDIFFERENT = &H400
Const OPENDLG_OFN_FILEMUSTEXIST = &H1000
Const OPENDLG_OFN_HIDEREADONLY = 4
Const OPENDLG_OFN_LONGNAMES = &H200000
Const OPENDLG_OFN_NOCHANGEDIR = 8
Const OPENDLG_OFN_NODEREFERENCELINKS = &H100000
Const OPENDLG_OFN_NOLONGNAMES = &H40000
Const OPENDLG_OFN_NONETWORKBUTTON = &H20000
Const OPENDLG_OFN_NOREADONLYRETURN = &H8000
Const OPENDLG_OFN_NOTESTFILECREATE = &H10000
Const OPENDLG_OFN_NOVALIDATE = 256
Const OPENDLG_OFN_OVERWRITEPROMPT = 2
Const OPENDLG_OFN_PATHMUSTEXIST = &H800
Const OPENDLG_OFN_READONLY = 1
Const OPENDLG_OFN_SHAREAWARE = &H4000
Const OPENDLG_OFN_SHOWHELP = 16
Const OPENDLG_OFN_SHAREFALLTHROUGH = 2
Const OPENDLG_OFN_SHARENOWARN = 1
Const OPENDLG_OFN_SHAREWARN = 0
' ----------------------------------------------------------------------------
DECLARE FUNCTION RQOPENDLG_GetOpenFileName LIB "COMDLG32" ALIAS "GetOpenFileNameA" _
                                                (pOpenfilename AS OPENDLG_OPENFILENAME) AS LONG
' ----------------------------------------------------------------------------
Type QOpenDialogNew Extends QObject
    PUBLIC:
        ' Old Properties
        ' --------------
        Filter As String
        FilterIndex As Long
        FileName As String * 2048            ' Input FileNames path is stripped when existing (???for XP compatibility)
        InitialDir As string
        Caption As string
        ' New Properties (!!! Compatibility !!!)
        ' --------------
        SelectedDir As string
        SelectedFile As QStringList
        SelectedPathFile As QStringList
        RestoreCurrentDirectory As long
        DefaultExtension As String
        FileNameBufferSize As Long
        ' Flags
        FlagsInit As Long
        MultiSelect As Long
        Explorer As Long        ' Useless, only for compatibility with V001
        HideReadOnly As Long
        OverWritePrompt As Long
        CreatePrompt As Long
        ExtensionDifferent As Long
        RQDlog AS OPENDLG_OPENFILENAME
        FileTitle As String
        CustomFilter As String
        FileMustExist As Long
        PathMustExist As Long
        SaveReadOnly As Long
    PUBLIC:
  With QOpenDialogNew
    Sub SetDefaultValues
        .FileNameBufferSize = 1024
        ' Old Properties
        .Filter = ("All Files(*.*)" & Chr$(0) & "*.*" & Chr$(0) & Chr$(0))
        .FilterIndex = 1
        .FileName = String$(.FileNameBufferSize, 0)    ' Return Drive:\Path\FileName.Ext
        .InitialDir = "C:" & Chr$(92)
        .Caption = "OPEN FILE"
        ' New Properties
        .CustomFilter = String$(1024, Chr$(0))
        .FileTitle = String$ (1024, Chr$(0))                 ' Only FileName.Ext if set <> NULLSTRING
        .DefaultExtension = ""
        ' Flags
        .RestoreCurrentDirectory = 0
        .FlagsInit = OPENDLG_OFN_EXPLORER Or OPENDLG_OFN_HIDEREADONLY ' = &H800000 Or = 4
        .MultiSelect = 0
        .HideReadOnly = 1
        .OverWritePrompt = 0
        .CreatePrompt = 0
        .ExtensionDifferent = 0
        .FileMustExist = 0
        .PathMustExist = 0
        .SaveReadOnly = 0
        '
        .RQDlog.lStructSize = SizeOf(QOpenDialogNew.RQDlog)
        .RQDlog.hwndOwner = Application.Handle
        .RQDlog.hInstance = 0            ' ???
        .RQDlog.lpstrFilter = Varptr(QOpenDialogNew.Filter)
        .RQDlog.lpstrCustomFilter = Varptr(QOpenDialogNew.CustomFilter) ' Dont statically Memorize the filter  (as in RQ)
        .RQDlog.nMaxCustFilter = 0
        .RQDlog.nFilterIndex = QOpenDialogNew.FilterIndex               ' Begin at the first element N 1
        .RQDlog.lpstrFile = Varptr(QOpenDialogNew.FileName)
        .RQDlog.nMaxFile = 1024            ' max PathFilenameExt lenght
        .RQDlog.lpstrFileTitle = Varptr(QOpenDialogNew.FileTitle)
        .RQDlog.nMaxFileTitle = 0         ' Read Doc
        .RQDlog.lpstrInitialDir =  Varptr(QOpenDialogNew.InitialDir)
        .RQDlog.lpstrTitle = Varptr(QOpenDialogNew.Caption)
        .RQDlog.flags = 0
        .RQDlog.nFileOffset = 0
        .RQDlog.nFileExtension = 0
        .RQDlog.lpstrDefExt = 0
        .RQDlog.lCustData = 0            ' lparam in msg passed to CallBack
        .RQDlog.lpfnHook = 0             ' callback function
        .RQDlog.lpTemplateName = 0       '
    End Sub
    Constructor
        SetDefaultValues
    End Constructor
    PUBLIC:
' EXECUTE
    Function Execute () As Long
        DefStr sTmp, sTmpFile
        DefInt iIndex = 1, iTmp
        .SelectedFile.Clear
        .SelectedPathFile.Clear
        ' FLAGS
        .RQDlog.flags = .FlagsInit
        ' HideREadOnly
        If .HideReadOnly = 0 Then .RQDlog.flags = .RQDlog.flags  And (Not (OPENDLG_OFN_HIDEREADONLY))
        ' OverWritePrompt
        If .OverWritePrompt = 1 Then .RQDlog.flags = .RQDlog.flags OR OPENDLG_OFN_OVERWRITEPROMPT
        ' MultiSelect
        If .MultiSelect = 1 Then .RQDlog.flags = .RQDlog.flags OR OPENDLG_OFN_ALLOWMULTISELECT
        ' Explorer Style
        If .CreatePrompt = 1 Then .RQDlog.flags = .RQDlog.flags OR OPENDLG_OFN_CREATEPROMPT
        ' FileMustExist
        If .FileMustExist = 1 Then .RQDlog.flags = .RQDlog.flags OR OPENDLG_OFN_FILEMUSTEXIST
        ' PathMustExist
        If .PathMustExist = 1 Then .RQDlog.flags = .RQDlog.flags OR OPENDLG_OFN_PATHMUSTEXIST
        ' SaveReadOnly
        If .SaveReadOnly = 1 Then .RQDlog.flags = .RQDlog.flags OR OPENDLG_OFN_READONLY
        ' Filter
        sTmp = .Filter
        If sTmp = "" Then
            sTmp = "All Files(*.*)" & Chr$(0) & "*.*" & Chr$(0) & Chr$(0)
        Else
            sTmp = ReplaceSubStr$(sTmp, "|", Chr$(0))
'            sTmp = ReplaceSubStr$(sTmp, ";", Chr$(0))
            sTmp = sTmp & Chr$(0) & Chr$(0)
        End If
        .Filter = sTmp
        .RQDlog.lpstrFilter = Varptr(QOpenDialogNew.Filter)
        ' FilterIndex
        .RQDlog.nFilterIndex = .FilterIndex
        ' FileName
        .FileName = .FileName & String$(.FileNameBufferSize - Len(.FileName), 0)
        .RQDlog.lpstrFile = Varptr(QOpenDialogNew.FileName)
        ' InitialDir
        .RQDlog.lpstrInitialDir =  Varptr(QOpenDialogNew.InitialDir)
        ' Caption
        .RQDlog.lpstrTitle = Varptr(QOpenDialogNew.Caption)
        ' Execute
        If .RestoreCurrentDirectory = 1 Then sTmp = CurDir$
        Result = RQOPENDLG_GetOpenFileName (.RQDlog)
        If .RestoreCurrentDirectory = 1 Then ChDir sTmp
        '  Set the SelectedPathFile/File StringList
        If .FileName <> "" Then
            sTmpFile = .FileName
            .SelectedDir = Field$(.FileName, Chr$(0), iIndex)
            Inc iIndex
            sTmp = Field$(.FileName, Chr$(0), iIndex)
            While sTmp <> ""
                .SelectedFile.AddItems (sTmp)
                .SelectedPathFile.AddItems (.SelectedDir & Chr$(92) & sTmp)
                Inc iIndex
                sTmp = Field$(.FileName, Chr$(0), iIndex)
            Wend
            If iIndex = 2 Then  ' Only one file selected, Filename = PathFileName
                .FileName = .FileName - Chr$(0)
                .SelectedDir = Left$(.FileName, RInstr(.FileName, "\\") - 1)
                .SelectedFile.AddItems (Mid$(.FileName, RInstr(.FileName, "\\") + 1))
                .SelectedPathFile.AddItems .FileName
            End If
            ' For compatbility with QOpenDialmogNew version 001
            .FileName = Left$(sTmpFile, Instr(sTmpFile, Chr$(0) & Chr$(0)) - 1)
        Else
            .SelectedFile.Clear
        End If
        .ExtensionDifferent = .RQDlog.Flags AND OPENDLG_OFN_EXTENSIONDIFFERENT
    End Function
  End With
End Type
' ----------------------------------------------------------------------------
' Replaces the Old QOPENDIALOG  (!!! NEW CANNOT BE DIM IN A FUNCTION/SUB !!!)
' $UNDEF QOPENDIALOG
' $DEFINE QOPENDIALOG QOPENDIALOGNEW
' ----------------------------------------------------------------------------
'
