' ----------------------------------------------------------------------------
' New QSaveDialog      March 3rd, 2006         by Jacques         Version  002
'
' This is based on RQDIALOG.INC  by  BILL K  1-2003
' ----------------------------------------------------------------------------
TYPE SAVEDLG_OPENFILENAME
    lStructSize AS LONG
    hwndOwner AS LONG
    hInstance AS LONG
    lpstrFilter AS LONG
    lpstrCustomFilter AS LONG
    nMaxCustFilter AS LONG
    nFilterIndex AS LONG
    lpstrFile AS LONG
    nMaxFile AS LONG
    lpstrFileTitle AS LONG
    nMaxFileTitle AS LONG
    lpstrInitialDir AS LONG
    lpstrTitle AS LONG
    flags AS LONG
    nFileOffset AS SHORT
    nFileExtension AS SHORT
    lpstrDefExt AS LONG
    lCustData AS LONG
    lpfnHook AS LONG
    lpTemplateName AS LONG
END TYPE
'------------------------------------------------------------------------------
Const SAVEDLG_OFN_ALLOWMULTISELECT = 512
Const SAVEDLG_OFN_CREATEPROMPT = &H2000
Const SAVEDLG_OFN_ENABLEHOOK = 32
Const SAVEDLG_OFN_ENABLETEMPLATE = 64
Const SAVEDLG_OFN_ENABLETEMPLATEHANDLE = 128
Const SAVEDLG_OFN_EXPLORER = &H80000
Const SAVEDLG_OFN_EXTENSIONDIFFERENT = &H400
Const SAVEDLG_OFN_FILEMUSTEXIST = &H1000
Const SAVEDLG_OFN_HIDEREADONLY = 4
Const SAVEDLG_OFN_LONGNAMES = &H200000
Const SAVEDLG_OFN_NOCHANGEDIR = 8
Const SAVEDLG_OFN_NODEREFERENCELINKS = &H100000
Const SAVEDLG_OFN_NOLONGNAMES = &H40000
Const SAVEDLG_OFN_NONETWORKBUTTON = &H20000
Const SAVEDLG_OFN_NOREADONLYRETURN = &H8000
Const SAVEDLG_OFN_NOTESTFILECREATE = &H10000
Const SAVEDLG_OFN_NOVALIDATE = 256
Const SAVEDLG_OFN_OVERWRITEPROMPT = 2
Const SAVEDLG_OFN_PATHMUSTEXIST = &H800
Const SAVEDLG_OFN_READONLY = 1
Const SAVEDLG_OFN_SHAREAWARE = &H4000
Const SAVEDLG_OFN_SHOWHELP = 16
Const SAVEDLG_OFN_SHAREFALLTHROUGH = 2
Const SAVEDLG_OFN_SHARENOWARN = 1
Const SAVEDLG_OFN_SHAREWARN = 0
'------------------------------------------------------------------------------
DECLARE FUNCTION RQSAVEDLG_GetSaveFileName LIB "COMDLG32" ALIAS "GetSaveFileNameA" _
                                                (pOpenfilename AS SAVEDLG_OPENFILENAME) AS LONG
'------------------------------------------------------------------------------
Type QSaveDialogNew Extends QObject
    PUBLIC:
        ' Old Properties
        ' --------------
        Filter As String
        FilterIndex As Long
        FileName As String
        InitialDir As string
        Caption As string
        ' New Properties (!!! Compatibility !!!)
        ' --------------
        SelectedDir As string
        SelectedFile As QStringList
        SelectedPathFile As QStringList
        RestoreCurrentDirectory As long
        DefaultExtension As String
        FileNameBufferSize As Long
        FlagsInit As Long
        MultiSelect As Long
        Explorer As Long        ' Useless, only for compatibility with V001
        HideReadOnly As Long
        OverWritePrompt As Long
        RQDlog AS SAVEDLG_OPENFILENAME
        FileTitle As String
        CustomFilter As String
        CreatePrompt As Long
        ExtensionDifferent As Long
        FileMustExist As Long
        PathMustExist As Long
        SaveReadOnly As Long
    PUBLIC:
  With QSaveDialogNew
    Sub SetDefaultValues
        .FileNameBufferSize = 1024
        ' Old Properties
        .Filter = ("All Files(*.*)" & Chr$(0) & "*.*" & Chr$(0) & Chr$(0))
        .FilterIndex = 1
        .FileName = String$(.FileNameBufferSize, 0)    ' Return Drive:\Path\FileName.Ext
        .InitialDir = "C:" & Chr$(92)
        .Caption = "SAVE FILE"
        ' New Properties
        .CustomFilter = String$(1024, Chr$(0))
        .FileTitle = String$ (1024, Chr$(0))                 ' Only FileName.Ext if set <> NULLSTRING
        .DefaultExtension = ""
        ' Flags
        .RestoreCurrentDirectory = 0
        .FlagsInit = SAVEDLG_OFN_EXPLORER Or SAVEDLG_OFN_HIDEREADONLY ' = &H800000 Or = 4
        .MultiSelect = 0
        .HideReadOnly = 1
        .OverWritePrompt = 0
        .CreatePrompt = 0
        .ExtensionDifferent = 0
        .FileMustExist = 0
        .PathMustExist = 0
        .SaveReadOnly = 0
        '
        .RQDlog.lStructSize = SizeOf (QSaveDialogNew.RQDlog) ' 21 * 4 + 2 * 2  ' 21 Long, 2 Short
        .RQDlog.hwndOwner = Application.Handle
        .RQDlog.hInstance = 0            ' ???
        .RQDlog.lpstrFilter = Varptr(QSaveDialogNew.Filter)
        .RQDlog.lpstrCustomFilter = Varptr(QSaveDialogNew.CustomFilter) ' Dont statically Memorize the filter  (as in RQ)
        .RQDlog.nMaxCustFilter = 0
        .RQDlog.nFilterIndex = QSaveDialogNew.FilterIndex               ' Begin at the first element N 1
        .RQDlog.lpstrFile = Varptr(QSaveDialogNew.FileName)
        .RQDlog.nMaxFile = 1024            ' max PathFilenameExt lenght
        .RQDlog.lpstrFileTitle = Varptr(QSaveDialogNew.FileTitle)
        .RQDlog.nMaxFileTitle = 0         ' Read Doc
        .RQDlog.lpstrInitialDir =  Varptr(QSaveDialogNew.InitialDir)
        .RQDlog.lpstrTitle = Varptr(QSaveDialogNew.Caption)
        .RQDlog.flags = 0
        .RQDlog.nFileOffset = 0
        .RQDlog.nFileExtension = 0
        .RQDlog.lpstrDefExt = 0
        .RQDlog.lCustData = 0            ' lparam in msg passed to CallBack
        .RQDlog.lpfnHook = 0             ' callback function
        .RQDlog.lpTemplateName = 0       '
    End Sub
    Constructor
        SetDefaultValues
    End Constructor
    PUBLIC:
' EXECUTE
    Function Execute () As Long
        DefStr sTmp, sTmpFile
        DefInt iIndex = 1, iTmp
        .SelectedFile.Clear
        .SelectedPathFile.Clear
        ' FLAGS
        .RQDlog.flags = .FlagsInit
        ' HideREadOnly
        If .HideReadOnly = 0 Then .RQDlog.flags = .RQDlog.flags And (Not (SAVEDLG_OFN_HIDEREADONLY))
        ' OverWritePrompt
        If .OverWritePrompt = 1 Then .RQDlog.flags = .RQDlog.flags OR SAVEDLG_OFN_OVERWRITEPROMPT
        ' MultiSelect
        If .MultiSelect = 1 Then .RQDlog.flags = .RQDlog.flags OR SAVEDLG_OFN_ALLOWMULTISELECT
        ' CreatePrompt
        If .CreatePrompt = 1 Then .RQDlog.flags = .RQDlog.flags OR SAVEDLG_OFN_CREATEPROMPT
        ' FileMustExist
        If .FileMustExist = 1 Then .RQDlog.flags = .RQDlog.flags OR SAVEDLG_OFN_FILEMUSTEXIST
        ' PathMustExist
        If .PathMustExist = 1 Then .RQDlog.flags = .RQDlog.flags OR SAVEDLG_OFN_PATHMUSTEXIST
        ' SaveReadOnly
        If .SaveReadOnly = 1 Then .RQDlog.flags = .RQDlog.flags OR SAVEDLG_OFN_READONLY
        ' Filter
        sTmp = .Filter
        If sTmp = "" Then
            sTmp = "All Files(*.*)" & Chr$(0) & "*.*" & Chr$(0) & Chr$(0)
        Else
            sTmp = ReplaceSubStr$(sTmp, "|", Chr$(0))
'            sTmp = ReplaceSubStr$(sTmp, ";", Chr$(0))
            sTmp = sTmp & Chr$(0) & Chr$(0)
        End If
        .Filter = sTmp
        .RQDlog.lpstrFilter = Varptr(QSaveDialogNew.Filter)
        ' FilterIndex
        .RQDlog.nFilterIndex = .FilterIndex
        ' FileName       
        .FileName = .FileName & String$(.FileNameBufferSize - Len(.FileName), 0)
        .RQDlog.lpstrFile = Varptr(QSaveDialogNew.FileName)
        ' InitialDir
        .RQDlog.lpstrInitialDir =  Varptr(QSaveDialogNew.InitialDir)
        ' Caption
        .RQDlog.lpstrTitle = Varptr(QSaveDialogNew.Caption)
        ' Execute
        If .RestoreCurrentDirectory = 1 Then sTmp = CurDir$
        Result = RQSAVEDLG_GetSaveFileName (.RQDlog)
        If .RestoreCurrentDirectory = 1 Then ChDir sTmp
        '  Set the SelectedPathFile/File StringList
        If .FileName <> "" Then
            sTmpFile = .FileName
            .SelectedDir = Field$(.FileName, Chr$(0), iIndex)
            Inc iIndex
            sTmp = Field$(.FileName, Chr$(0), iIndex)
            While sTmp <> ""
                .SelectedFile.AddItems (sTmp)
                .SelectedPathFile.AddItems (.SelectedDir & Chr$(92) & sTmp)
                Inc iIndex
                sTmp = Field$(.FileName, Chr$(0), iIndex)
            Wend
            If iIndex = 2 Then      ' Only one file selected, Filename = PathFileName
                .FileName = .FileName - Chr$(0)
                .SelectedDir = Left$(.FileName, RInstr(.FileName, "\\") - 1)
                .SelectedFile.AddItems (Mid$(.FileName, RInstr(.FileName, "\\") + 1))
                .SelectedPathFile.AddItems .FileName
            End If
            ' For compatbility with QOpenDialmogNew version 001
            .FileName = Left$(sTmpFile, Instr(sTmpFile, Chr$(0) & Chr$(0)) - 1)
         Else
            .SelectedFile.Clear
         End If
        .ExtensionDifferent = .RQDlog.Flags AND SAVEDLG_OFN_EXTENSIONDIFFERENT
    End Function
  End With
End Type
' ----------------------------------------------------------------------------
' Replaces the Old QSAVEDIALOG  (!!! NEW CANNOT BE DIM IN A FUNCTION/SUB !!!)
' $UNDEF QSAVEDIALOG
' $DEFINE QSAVEDIALOG QSAVEDIALOGNEW
' ----------------------------------------------------------------------------
